// common.h -- miscelaneous cam functions

#ifndef __COMMON_H__
#define __COMMON_H__

#include "btkcam.h"

#include <stdio.h>
#include "stats.h"
#include "cam.h"

#define _DEBUG_OVERRIDE -1
#define _DEBUG_SILENT 0
#define _DEBUG_BASIC 1
#define _DEBUG_EXTENDED 2
#define _DEBUG_VERBOSE 3

#define _MAX_CARDSERVERS 10

// --------------------------- debug function declares ------------------------------
#define _slogd(transaction, level, indent, newlines) _flog(transaction, level, indent, "done.", 0, NULL, 0, 0, 0, newlines)

struct bisskeys
	{
	char pces[20];
	char keys[33];
	};

char *_logmf(const char *format, ...);
void set_debug_level( int level );

#define NO_TRANS 0
unsigned int _log_begin_trans( void );
void _log_commit_trans( unsigned int, bool show_osd = false );
void _log_abort_trans( unsigned int );
void _flog(unsigned int transaction, int level, int indent_message, char *message, int indent_data, unsigned char *data, int len, int cols, int newlines_between, int newlines_after, bool show_osd = false);
void _slog(unsigned int transaction, int level, int indent_message, char *message, int newlines, bool show_osd = false);
// ----------------------------------------------------------------------------------

double microseconds( void );

int fexists(const char * filename);

bool memzero( unsigned char *src, unsigned int size);
bool memequal(unsigned char *src_1, unsigned char *src_2, unsigned int size);

char *strsub(char *dest, char *src, int start, int length);
char *strltr(char *dest, char *src);
char *strrtr(char *dest, char *src);
char *stratr(char *dest, char *src);

void unix2dos(char *dest, char *source);
int config_read_settings( void );

void config_show_settings( char *settings );
char *get_time( void );
char *get_time_nf( void );
void config_read_fix_dos_style( char *config_line );

unsigned char *load_file(char *file_path, int *size);


char *file_name_from_path(char *path);

void 	keystr_to_key(char *src, unsigned char *cw0, unsigned char *cw1);
void xor_buffers(unsigned char *dest, unsigned char *src_1, unsigned char *src_2, unsigned int length);

unsigned int get_local_address( void );
char *address_int_to_human_readable(unsigned int address, char *readable);
void dump(unsigned char *buffer, int length);

int xtoi(char *hex);

unsigned int _htonl(unsigned int hostlong);
unsigned short int _htons(unsigned short int hostshort);
unsigned int _ntohl(unsigned int netlong);
unsigned short int _ntohs(unsigned short int netshort);

#endif
